import wx
import os
import random
import threading
from datetime import datetime
import time

import data_gen_gui


class batchThread(threading.Thread):
    def __init__(self):
        super(batchThread, self).__init__()
        self._stop = threading.Event()

    def stop(self):
        self.endBatch()
        self._stop.set()

    def stopped(self):
        return self._stop.isSet()

    
    def run(self):
        self.newBatch()
        while not self.stopped():
            self.createData()

    def newBatch(self):
        self.currFileNr=0
        self.measWritten=0
        mainFrame.piecesWritten.SetLabel(str(self.measWritten))
        
        i=0

        fexists=1
        while fexists:
            filename=file_nr2name(i)

            if os.path.exists(filename):
                os.remove(filename)
            else:
                fexists=0
                
            i+=1

        if os.path.exists('linempty.dat'):
            os.remove('linempty.dat')

        print 'New batch started'

    def createData(self):
        filename=file_nr2name(self.currFileNr)

        f = open(filename,'w')

        if self.currFileNr==0:
            f.write('17100 17200 18200 18300 18200\n')
            
        print 'New file'
        for i in range(0,10):
            f.write(str(random.randint(17080, 17210))+' ')
            f.write(str(random.randint(18070, 18310))+' ')
            f.write(str(random.randint(18070, 20000))+' ')
            d=datetime.now()
            ts=d.strftime('%Y %m %d %H %M %S')
            f.write(ts+'\n')

            self.measWritten+=1
            mainFrame.piecesWritten.SetLabel(str(self.measWritten))
            time.sleep(1.5)
            

        self.currFileNr+=1
        
        f.close()
        
    def endBatch(self):
        f = open('linempty.dat','w')
        f.close()

        print 'End of batch'


def file_nr2name(file_nr):
    file_name=str(file_nr)
    while len(file_name)<8:
        file_name='0'+file_name
    file_name=file_name+'.dat'
    return file_name

def startBatch(event):
    global thread
    mainFrame.startBatchButton.Disable()
    mainFrame.endBatchButton.Enable()
    thread=batchThread()
    thread.start()

def endBatch(event):
    global thread
    mainFrame.startBatchButton.Enable()
    mainFrame.endBatchButton.Disable()
    thread.stop()

app = wx.App(0)
mainFrame = data_gen_gui.MainFrame(None)
mainFrame.Show(True)
mainFrame.startBatchButton.Bind(wx.EVT_BUTTON, startBatch)
mainFrame.endBatchButton.Bind(wx.EVT_BUTTON, endBatch)


app.MainLoop()
