import gui
import wx

class MainFrame(gui.MainFrame):
    def __init__(self,parent):
        gui.MainFrame.__init__(self,parent)

    def batchSelect(self,event):
        batchSelectFrame = BatchSelectFrame(None)
        batchSelectFrame.Show(True)


class BatchSelectFrame(gui.BatchSelectFrame):
    def __init__(self,parent,batchData):
        gui.BatchSelectFrame.__init__(self,parent)

        self.batchData=batchData
        #dataList init
        listColumns=['live',
                     'batch_name',
                     'timestamp',
                     'meas_17_countOK',
                     'meas_17_countNOK',
                     'meas_17_percentNOK',
                     'meas_17_OKAverage',
                     'meas_17_OKMin',
                     'meas_17_OKMax',
                     'meas_18_1_countOK',
                     'meas_18_1_countNOK',
                     'meas_18_1_percentNOK',
                     'meas_18_1_OKAverage',
                     'meas_18_1_OKMin',
                     'meas_18_1_OKMax',
                     'meas_18_2_countOK',
                     'meas_18_2_countNOK',
                     'meas_18_2_percentNOK',
                     'meas_18_2_OKAverage',
                     'meas_18_2_OKMin',
                     'meas_18_2_OKMax']
        i=0
        self.listColumnIds={}
        for col in listColumns:
            self.listColumnIds[col]=i
            i+=1
        
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['live'],'')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['live'], 40)

        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['batch_name'],'Batch name')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['batch_name'], 80)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['timestamp'],'Timestamp')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['timestamp'], 115)
        
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_17_countOK'],'BW OK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_17_countOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_17_countNOK'],'NOK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_17_countNOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_17_percentNOK'],'%NOK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_17_percentNOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_17_OKAverage'],'OK AVG')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_17_OKAverage'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_17_OKMin'],'MIN')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_17_OKMin'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_17_OKMax'],'MAX')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_17_OKMax'], 50)

        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_1_countOK'],'SC OK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_1_countOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_1_countNOK'],'NOK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_1_countNOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_1_percentNOK'],'%NOK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_1_percentNOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_1_OKAverage'],'OK AVG')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_1_OKAverage'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_1_OKMin'],'MIN')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_1_OKMin'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_1_OKMax'],'MAX')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_1_OKMax'], 50)

        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_2_countOK'],'Ins OK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_2_countOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_2_countNOK'],'NOK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_2_countNOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_2_percentNOK'],'%NOK')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_2_percentNOK'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_2_OKAverage'],'OK AVG')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_2_OKAverage'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_2_OKMin'],'MIN')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_2_OKMin'], 50)
        self.batchSelectListCtrl.InsertColumn(self.listColumnIds['meas_18_2_OKMax'],'MAX')
        self.batchSelectListCtrl.SetColumnWidth(self.listColumnIds['meas_18_2_OKMax'], 50)
        #END - dataList init

        #event bindings
        self.StdDialogButtonSizerOK.Bind( wx.EVT_BUTTON, self.okButton )
        self.batchSelectListCtrl.Bind( wx.EVT_LIST_ITEM_ACTIVATED, self.okButton ) #=doubleclick
        self.StdDialogButtonSizerCancel.Bind( wx.EVT_BUTTON, self.cancelButton)

        self.IdList=[] #list of batch Ids, corresponding to the batch list written later in batchSelect

    def okButton(self,event):
        index=self.batchSelectListCtrl.GetNextItem(-1,wx.LIST_NEXT_ALL,wx.LIST_STATE_SELECTED)
        self.batchData.changeBatch(self.IdList[index])
        self.Destroy()

    def cancelButton(self,event):
        self.Destroy()
        
